r(K) :-
	var_chars(VCh),
	conv_vars_to_letters(K,VCh,_),
	write(K).
v2c(K) :-
	var_chars(VCh),
	conv_vars_to_letters(K,VCh,_).


% conv_vars_to_letters( +Term, +ChLIn, -ChLOut )
% variables in the term +Term unifies with names from the list +ChLIn;
% unused variable names returns in the list -ChLOut

conv_vars_to_letters( _, [], [] ) :- !.
conv_vars_to_letters( Term, [ Ch|ChL ], ChL ) :-
  var( Term ), Term = Ch, !.
conv_vars_to_letters( [], ChL, ChL ) :- !.
conv_vars_to_letters( [ Term|TermL ], ChLIn, ChLOut ) :-
  conv_vars_to_letters( Term, ChLIn, ChLOut1 ),
  conv_vars_to_letters( TermL, ChLOut1, ChLOut ), !.
conv_vars_to_letters( Term, ChLIn, ChLOut ) :-
  Term =.. [ _|SubTermL ],
  conv_vars_to_letters( SubTermL, ChLIn, ChLOut ), !.



% var_chars( -ChL )
% returns the list -ChL of typical Prolog-variable names
 
var_chars( [
 'X', 'Y', 'Z', 'U', 'V', 'W',
 'X1', 'Y1', 'Z1', 'U1', 'V1', 'W1',
 'X2', 'Y2', 'Z2', 'U2', 'V2', 'W2',
 'X3', 'Y3', 'Z3', 'U3', 'V3', 'W3',
 'X4', 'Y4', 'Z4', 'U4', 'V4', 'W4' ] ).


